/*
	Author: Aaron Clark - EpochMod.com

    Contributors:

	Description:
	Epoch gamemode server Side map specific configs for altis.

    Licence:
    Arma Public License Share Alike (APL-SA) - https://www.bistudio.com/community/licenses/arma-public-license-share-alike

    Github:
    https://github.com/EpochModTeam/Epoch/tree/release/Sources/epoch_server_settngs/configs/maps/altis.h
*/
class Tanoa : Default
{
	worldSize = 0; // 0 = default to worldSize command
	plantLimit = 10;
	// vehicles - Max vehicle slots is calculated from per vehicle limits below. Warning! Higher the number lower the performance.
	vehicleSpawnTypes[] = {
		{"FlatAreaCity",1},
		{"FlatAreaCitySmall",1},
		{"NameCity",2},
		{"NameVillage",1},
		{"NameCityCapital",4},
		{"Airport",5}
	};

	allowedVehiclesList[] = {
		{"C_Offroad_01_EPOCH",6},
		{"C_Quadbike_01_EPOCH",6},
		{"C_Hatchback_01_EPOCH",8},
		{"C_Hatchback_02_EPOCH",8},
		{"C_SUV_01_EPOCH",8},
		{"C_Rubberboat_EPOCH",3},
		{"C_Rubberboat_02_EPOCH",3},
		{"C_Rubberboat_03_EPOCH",3},
		{"C_Rubberboat_04_EPOCH",3},
		{"C_Van_01_box_EPOCH",6},
		{"C_Van_01_transport_EPOCH",6},
		{"C_Boat_Civil_01_EPOCH",5},
		{"C_Boat_Civil_01_police_EPOCH",3},
		{"C_Boat_Civil_01_rescue_EPOCH",3},
		{"B_Heli_Light_01_EPOCH",2},
		{"B_SDV_01_EPOCH",2},
		{"B_MRAP_01_EPOCH",3},
		{"I_MRAP_03_EPOCH", 3},
		{"B_Truck_01_transport_EPOCH",1},
		{"B_Truck_01_covered_EPOCH",2},
		{"B_Truck_01_mover_EPOCH",1},
		{"B_Truck_01_box_EPOCH",1},
		{"O_Truck_02_covered_EPOCH",2},
		{"O_Truck_02_transport_EPOCH",1},
		{"O_Truck_03_covered_EPOCH",1},
		{"O_Truck_02_box_EPOCH",1},
		{"I_Heli_light_03_unarmed_EPOCH",1},
		{"O_Heli_Light_02_unarmed_EPOCH",1},
		{"I_Heli_Transport_02_EPOCH",1},
		{"O_Heli_Transport_04_EPOCH",1},
		{"O_Heli_Transport_04_bench_EPOCH",1},
		{"O_Heli_Transport_04_box_EPOCH",1},
		{"O_Heli_Transport_04_covered_EPOCH",1},
		{"B_Heli_Transport_03_unarmed_EPOCH",1},
		{"jetski_epoch",5},
		{"K01",1},
		{"K02",1},
		{"K03",1},
		{"K04",1},
		{"ebike_epoch",5},
		{"mosquito_epoch",4},
		{"C_Heli_Light_01_civil_EPOCH",3},
		// apex
		{"C_Boat_Transport_02_F",1},
		{"C_Scooter_Transport_01_F",3},
		{"C_Offroad_02_unarmed_F",2},
		{"I_C_Offroad_02_unarmed_F",2},
		{"B_T_LSV_01_unarmed_F",2},
		{"O_LSV_02_unarmed_F",2},
		{"O_T_LSV_02_unarmed_F",2},
		{"C_Plane_Civil_01_F",3},
		{"C_Plane_Civil_01_racing_F",1},
		{"B_CTRG_LSV_01_light_F",2},
		{"B_LSV_01_unarmed_F",2},
		{"B_T_VTOL_01_infantry_F",1},
		{"B_T_VTOL_01_vehicle_F",1}
	};
	allowedVehiclesList_CUP[] = {
		{"C_Offroad_01_EPOCH",4},
		{"C_Quadbike_01_EPOCH",4},
		{"C_Hatchback_01_EPOCH",5},
		{"C_Hatchback_02_EPOCH",5},
		{"C_SUV_01_EPOCH",5},
		{"C_Rubberboat_EPOCH",2},
		{"C_Rubberboat_02_EPOCH",2},
		{"C_Rubberboat_03_EPOCH",2},
		{"C_Rubberboat_04_EPOCH",2},
		{"C_Van_01_box_EPOCH",4},
		{"C_Van_01_transport_EPOCH",4},
		{"C_Boat_Civil_01_EPOCH",5},
		{"C_Boat_Civil_01_police_EPOCH",2},
		{"C_Boat_Civil_01_rescue_EPOCH",2},
		{"B_Heli_Light_01_EPOCH",2},
		{"B_SDV_01_EPOCH",2},
		{"B_MRAP_01_EPOCH",2},
		{"I_MRAP_03_EPOCH", 2},
		{"B_Truck_01_transport_EPOCH",1},
		{"B_Truck_01_covered_EPOCH",2},
		{"B_Truck_01_mover_EPOCH",1},
		{"B_Truck_01_box_EPOCH",1},
		{"O_Truck_02_covered_EPOCH",2},
		{"O_Truck_02_transport_EPOCH",1},
		{"O_Truck_03_covered_EPOCH",1},
		{"O_Truck_02_box_EPOCH",1},
		{"I_Heli_light_03_unarmed_EPOCH",1},
		{"O_Heli_Light_02_unarmed_EPOCH",1},
		{"I_Heli_Transport_02_EPOCH",1},
		{"O_Heli_Transport_04_EPOCH",1},
		{"O_Heli_Transport_04_bench_EPOCH",1},
		{"O_Heli_Transport_04_box_EPOCH",1},
		{"O_Heli_Transport_04_covered_EPOCH",1},
		{"B_Heli_Transport_03_unarmed_EPOCH",1},
		{"jetski_epoch",3},
		{"K01",1},
		{"K02",1},
		{"K03",1},
		{"K04",1},
		{"ebike_epoch",3},
		{"mosquito_epoch",3},
		{"C_Heli_Light_01_civil_EPOCH",2},
		{"CUP_C_Fishing_Boat_Chernarus",2},
		{"CUP_C_LR_Transport_CTK",2},
		{"CUP_B_Zodiac_USMC",2},
		{"CUP_C_Skoda_Red_CIV",2},
		{"CUP_C_Skoda_White_CIV",2},
		{"CUP_C_Skoda_Blue_CIV",2},
		{"CUP_C_Skoda_Green_CIV",2},
		{"CUP_C_SUV_CIV",2},
		{"CUP_B_HMMWV_Transport_USA",2},
		{"CUP_B_HMMWV_Unarmed_USA",2},
		{"CUP_C_SUV_TK",2},
		{"CUP_B_LR_Transport_CZ_D",2},
		{"CUP_C_Datsun_Covered",2},
		{"CUP_C_Datsun_Plain",2},
		{"CUP_C_Datsun_Tubeframe",2},
		{"CUP_C_Datsun_4seat",2},
		{"CUP_C_Datsun",2},
		{"CUP_C_Golf4_green_Civ",2},
		{"CUP_C_Golf4_red_Civ",2},
		{"CUP_C_Golf4_blue_Civ",2},
		{"CUP_C_Golf4_black_Civ",2},
		{"CUP_C_Golf4_kitty_Civ",2},
		{"CUP_C_Golf4_reptile_Civ",2},
		{"CUP_C_Golf4_camodigital_Civ",2},
		{"CUP_C_Golf4_camodark_Civ",2},
		{"CUP_C_Golf4_camo_Civ",2},
		{"CUP_B_M1030",2},
		{"CUP_C_Ural_Civ_03",2},
		{"CUP_C_Ural_Open_Civ_03",2},
		{"CUP_C_Ural_Civ_02",2},
		{"CUP_B_TowingTractor_USMC",2},
		{"CUP_C_C47_CIV",2},
		{"CUP_B_LR_Transport_CZ_W",2},
		{"CUP_C_Golf4_white_Civ",2},
		{"CUP_C_Golf4_whiteblood_Civ",2},
		{"CUP_C_Golf4_yellow_Civ",2},
		{"CUP_C_Octavia_CIV",2},
		{"CUP_C_Ural_Civ_01",2},
		{"CUP_C_Ural_Open_Civ_01",2},
		{"CUP_B_Ural_CDF",2},
		{"CUP_B_Ural_Open_CDF",2},
		{"CUP_C_Ural_Open_Civ_02",2},
		{"CUP_B_HMMWV_Ambulance_USA",2},
		{"CUP_C_UAZ_Unarmed_TK_CIV",2},
		{"CUP_C_UAZ_Open_TK_CIV",2},
		{"CUP_B_UAZ_Unarmed_CDF",2},
		{"CUP_B_Ural_Empty_CDF",2},
		{"CUP_C_DC3_CIV",2},
		//apex
		{"C_Boat_Transport_02_F",1},
		{"C_Scooter_Transport_01_F",3},
		{"C_Offroad_02_unarmed_F",2},
		{"I_C_Offroad_02_unarmed_F",2},
		{"B_T_LSV_01_unarmed_F",2},
		{"O_LSV_02_unarmed_F",2},
		{"O_T_LSV_02_unarmed_F",2},
		{"C_Plane_Civil_01_F",3},
		{"C_Plane_Civil_01_racing_F",1},
		{"B_CTRG_LSV_01_light_F",2},
		{"B_LSV_01_unarmed_F",2},
		{"B_T_VTOL_01_infantry_F",1},
		{"B_T_VTOL_01_vehicle_F",1}
	};
	traderBlds[] = { "Land_Kiosk_blueking_F", "Land_FuelStation_Build_F", "Land_CarService_F", "Land_i_Garage_V1_F", "Land_i_Shed_Ind_F", "Land_i_Shop_01_V1_F" };
	telePos[] = {
		// N [-0.286865,8.17383,-10.3098]
		// S [-0.415527,-7.05298,-10.3098]
		// E [13.5127,0.410156,-10.3098]
		// W [-14.4316,0.112793,-10.3098]

		// template city { "Transport_C_EPOCH", { -0.286865,8.17383,-10.3098 }, "", "north" },
        { "Transport_W_EPOCH", { -14.4316,0.112793,-10.3098 }, "", { 2015.21,10659.6,0 } },
        { "Transport_C_EPOCH", { -0.286865,8.17383,-10.3098  }, "", { 5027.48,5210.25,0 } },
        { "Transport_E_EPOCH", { 13.5127,0.410156,-10.3098 }, "", { 11779.6,13056.5,0 } }
	};
	propsPos[] = {
        // Western Trader Camp
        { "Land_ClutterCutter_large_F", {2007.84,10661.6,-0.0380335}, {{0.347282,-0.937045,0.0366348},{0.0239934,0.0479322,0.998562}}, true },
        { "Land_PCSet_01_case_F", {2014.64,10649,0.624558}, {{-0.600211,0.799842,0},{0,0,1}}, true },
        { "Land_PCSet_01_case_F", {2014.28,10648.7,0.582048}, {{-0.600211,0.799842,0},{0,0,1}}, true },
        { "Land_PCSet_01_case_F", {2014.46,10648.9,0.603722}, {{-0.600211,0.799842,0},{0,0,1}}, true },
        { "Land_WaterCooler_01_new_F", {2014.08,10648.5,-0.260181}, {{0.811798,0.583938,0},{0,0,1}}, true },
        { "Land_SatellitePhone_F", {2014.89,10649.3,0.655825}, {{-0.632394,0.774647,0},{0,0,1}}, true },
        { "Land_CampingTable_F", {2014.92,10649.3,-0.15448}, {{0.601662,-0.798751,0},{0,0,1}}, true },
        { "Land_ClutterCutter_large_F", {2018.95,10649.5,-0.0333686}, {{0.347338,-0.935093,0.0704037},{-0.0159977,0.0691583,0.997477}}, true },
        { "Land_PortableGenerator_01_F", {2017.53,10650.7,0.0167627}, {{0.167069,0.984685,-0.0498395},{-0.0159977,0.0532507,0.998453}}, true },
        { "Land_Portable_generator_F", {2018.9,10650.6,0.000555515}, {{-0.138701,-0.989045,0.0505266},{-0.0159977,0.0532507,0.998453}}, true },
        { "Land_Laptop_device_F", {2018.59,10650.9,0.814502}, {{-0.14656,-0.98792,0.0503374},{-0.01602,0.0532506,0.998453}}, true },
        { "Land_Laptop_device_F", {2019.1,10650.6,0.814545}, {{-0.703214,-0.71048,0.0266092},{-0.01602,0.0532506,0.998453}}, true },
        { "Land_ClutterCutter_medium_F", {2025.28,10661.6,0.0389977}, {{0,0.999091,-0.0426276},{-0.206142,0.0417121,0.977633}}, true },
        { "Land_ClutterCutter_large_F", {2019.41,10663,0.0390873}, {{0,0.999201,-0.0399685},{-0.0426276,0.0399322,0.998293}}, true },
        { "Land_ClutterCutter_large_F", {2022.16,10656.5,0.0390854}, {{0,0.999712,-0.0239912},{-0.0744588,0.0239246,0.996937}}, true },
        { "Land_ClutterCutter_large_F", {2015.04,10651.8,0.287385}, {{0,0.998581,-0.0532597},{-0.0426905,0.0532112,0.99767}}, true },
        { "Land_ClutterCutter_large_F", {2016.03,10668.7,-0.0298233}, {{0.347377,-0.937048,0.0356291},{0.00532655,0.0399664,0.999187}}, true },
        { "Land_ClutterCutter_large_F", {2024.52,10672.5,-0.0130653}, {{0.347026,-0.937267,0.0332296},{-0.0452868,0.0186436,0.9988}}, true },
        { "Land_ClutterCutter_large_F", {2033.07,10678.5,-0.0347009}, {{0.347303,-0.934146,0.0821643},{-0.0213272,0.0797273,0.996589}}, true },
        { "Land_CampingTable_F", {2018.42,10650.7,0.00127506}, {{-0.112074,-0.992383,0.0511313},{-0.0159977,0.0532507,0.998453}}, true },
        { "Land_ClutterCutter_large_F", {2034.44,10765.1,0.00799751}, {{0.347371,-0.936863,-0.0402548},{0.00800059,-0.0399655,0.999169}}, true },
        { "Land_ClutterCutter_large_F", {2037.75,10757.8,0.033432}, {{0.347322,-0.932357,-0.100385},{-0.0186628,-0.113901,0.993317}}, true },
        { "Land_ClutterCutter_large_F", {2031.72,10772.4,0}, {{0.347204,-0.937485,-0.0238802},{-0.031983,-0.037287,0.998793}}, true },
        { "ArrowDesk_L_F", {2026.45,10773.7,-0.000289917}, {{-0.929983,-0.367323,0.0143572},{0.0133342,0.00532276,0.999897}}, true },
        { "ArrowDesk_L_F", {2035.43,10777.4,-0.00571823}, {{-0.929946,-0.367052,0.0217362},{0.0160037,0.0186541,0.999698}}, true },
        { "ArrowDesk_R_F", {2035.24,10777.3,0.000299454}, {{0.916943,0.398406,-0.0221131},{0.0160037,0.0186541,0.999698}}, true },
        { "ArrowDesk_R_F", {2026.26,10773.6,0.000107765}, {{0.916979,0.398678,-0.0143494},{0.0133313,0.00532603,0.999897}}, true },
        { "Land_ClutterCutter_large_F", {2056.26,10709.9,-0.0134869}, {{0.346418,-0.937394,-0.0358693},{0.0744595,-0.0106397,0.997167}}, true },
        { "Land_ClutterCutter_large_F", {2057.4,10703.7,-0.0130305}, {{0.346983,-0.937337,-0.0316501},{0.0479432,-0.0159753,0.998722}}, true },
        { "Land_ClutterCutter_large_F", {2057.99,10698.2,-0.018671}, {{0.34714,-0.937554,0.0220326},{0.0373061,0.0372803,0.998608}}, true },
        { "Land_ClutterCutter_large_F", {2058.32,10693.7,-0.0213284}, {{0.347282,-0.936475,0.0490863},{0.0239934,0.0612004,0.997837}}, true },
        { "Land_ClutterCutter_large_F", {2065.18,10700.3,-0.00999784}, {{-0.993507,-0.113753,0.00219393},{-0.00267442,0.0426275,0.999087}}, true },
        { "Land_ClutterCutter_large_F", {2051.32,10688.2,0}, {{0.347338,-0.936567,0.0468822},{0.0159937,0.0559042,0.998308}}, true },
        { "Land_ClutterCutter_large_F", {2041.39,10682.8,-0.0593615}, {{0.34655,-0.93622,0.0582668},{0.069167,0.0874509,0.993765}}, true },
        { "Land_ClutterCutter_large_F", {2045.72,10739,-0.0179958}, {{0.347026,-0.93781,0.00927076},{0.0452867,0.0266297,0.998619}}, true },
        { "Land_ClutterCutter_large_F", {2048.22,10732.7,0.00805712}, {{0.347066,-0.934018,-0.0845894},{0.0426276,-0.0743919,0.996318}}, true },
        { "Land_ClutterCutter_large_F", {2049.46,10729.7,-0.0106125}, {{0.345703,-0.93435,-0.0864863},{0.09819,-0.055642,0.993611}}, true },
        { "Land_ClutterCutter_large_F", {2051.39,10724.1,-0.00470018}, {{0.343437,-0.922599,-0.175677},{0.150273,-0.130663,0.979972}}, true },
        { "Land_ClutterCutter_large_F", {2054.08,10717.6,-0.0200381}, {{0.341318,-0.925145,-0.166157},{0.186028,-0.106788,0.976724}}, true },
        { "Land_ClutterCutter_large_F", {2040.66,10751.2,-0.00997543}, {{0.345324,-0.931118,-0.117348},{0.108686,-0.0845203,0.990476}}, true },
        { "Land_ClutterCutter_large_F", {2043.78,10744.2,0.0206614}, {{0.34714,-0.937348,-0.0295196},{-0.0373079,-0.0452552,0.998279}}, true },
        { "Land_Razorwire_F", {1997.36,10647.3,0.0347066}, {{-0.836157,-0.539158,0.10075},{0.0771031,0.0663211,0.994815}}, true },
        { "Land_Razorwire_F", {2003.48,10645.5,-0.29515}, {{0.443978,-0.893206,0.0711733},{0.132163,0.143841,0.980736}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2003.41,10647.1,-0.533029}, {{-0.307788,0.951455,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2009.15,10646.8,-0.7}, {{-0.71281,-0.701357,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {1998.64,10649.5,0.0644999}, {{0.806509,0.591222,0},{0,0,1}}, true },
        { "Land_Razorwire_F", {1995.89,10667.8,-0.161806}, {{0.55434,-0.832145,-0.0155343},{0.0876605,0.0398146,0.995354}}, true },
        { "Land_Razorwire_F", {2007.71,10677.8,-0.0676603}, {{0.665774,-0.746115,-0.00759386},{0.0293202,0.0159908,0.999442}}, true },
        { "Land_Razorwire_F", {2002.05,10672.6,-0.106432}, {{0.662338,-0.745321,-0.0761899},{0.0876605,-0.023901,0.995864}}, true },
        { "Land_Razorwire_F", {1993.53,10653.5,-0.209675}, {{-0.831984,-0.532798,0.154686},{0.203641,-0.0339196,0.978458}}, true },
        { "Land_HBarrier_01_big_tower_green_F", {1993.02,10661.9,-0.983466}, {{0.81747,0.575971,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {1996.53,10666.8,0.0133524}, {{0.581407,-0.813399,-0.0186679},{0.0876605,0.0398146,0.995354}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2008.39,10675.5,0.00380754}, {{0.570993,-0.820939,0.00513684},{0.0293202,0.0266456,0.999215}}, true },
        { "Land_HBarrier_01_big_4_green_F", {1994.23,10655.7,-0.452624}, {{0.806509,0.591222,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2002.15,10670.6,0.0120964}, {{0.626242,-0.778572,-0.0405855},{0.0876605,0.0185909,0.995977}}, true },
        { "Land_Razorwire_F", {2017.15,10641.4,0.00270033}, {{-0.107352,-0.978113,0.178246},{0.0319849,0.175791,0.983908}}, true },
        { "Land_Razorwire_F", {2010.01,10644.1,0.143356}, {{-0.579508,-0.805183,0.125902},{0.0133313,0.145101,0.989327}}, true },
        { "Land_Razorwire_F", {2028.2,10649.6,-0.011622}, {{0.959483,-0.265481,0.0944044},{-0.0876609,0.0371643,0.995457}}, true },
        { "Land_Razorwire_F", {2024.16,10643.8,-0.0291944}, {{0.514935,-0.849056,0.118091},{-0.0399685,0.11383,0.992696}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2022.61,10644.7,-0.17352}, {{0.528829,-0.848728,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2015.36,10643.2,4.76837e-007}, {{0.135001,0.990846,0},{0,0,1}}, true },
        { "Land_NetFence_02_m_gate_v1_F", {2020.37,10664.9,0.0390873}, {{-0.395113,0.918633,0},{0,0,1}}, false },
        { "Land_Razorwire_F", {2030.13,10657.3,0.260143}, {{0.953535,-0.256933,0.15734},{-0.186028,-0.0913072,0.978293}}, true },
        { "Land_Razorwire_F", {2029.48,10664.7,-0.300159}, {{0.82649,0.505114,0.248545},{-0.318502,0.0555165,0.946295}}, true },
        { "Land_HBarrier_01_big_tower_green_F", {2013.94,10676.5,0.000588894}, {{-0.841341,-0.540258,0.0163131},{-0.0080009,0.0426263,0.999059}}, true },
        { "Land_HBarrier_01_wall_6_green_F", {2017.09,10657.3,0}, {{-0.512743,0.858542,0},{0,0,1}}, true },
        { "Land_HBarrier_01_wall_6_green_F", {2011.03,10652.3,0}, {{-0.698165,0.715937,0},{0,0,1}}, true },
        { "Land_HBarrier_01_wall_corridor_green_F", {2021.18,10662.7,0.039}, {{-0.980078,-0.198615,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2026.65,10650.6,0}, {{-0.955366,0.295425,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2027.22,10664.2,-0.592677}, {{-0.752581,-0.658499,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {2028.32,10658.6,-0.441137}, {{-0.99605,0.0887906,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {2017.13,10654.4,-0.0457668}, {{-0.666717,0.745311,0},{0,0,1}}, true },
        { "Land_IRMaskingCover_02_F", {2015.13,10650.4,0.00850105}, {{0.628506,-0.777804,0},{0,0,1}}, true },
        { "Land_BagFence_01_long_green_F", {2013.16,10672.1,0.0394974}, {{0.605195,-0.79572,0.0238567},{0.00265199,0.0319829,0.999485}}, true },
        { "Land_BagFence_01_long_green_F", {2020.07,10674.7,0.000702858}, {{0.852466,0.521851,0.0311863},{-0.0479448,0.0186381,0.998676}}, true },
        { "Land_BagFence_01_long_green_F", {2022.01,10669.1,0.00173807}, {{0.604338,-0.795073,0.0513228},{-0.0532575,0.0239597,0.998293}}, true },
        { "Land_BagFence_01_long_green_F", {2023.92,10668.7,0.00083971}, {{0.803457,0.595343,0.00483694},{-0.0532575,0.0637782,0.996542}}, true },
        { "Land_HBarrier_01_line_1_green_F", {2024.57,10667,1.15882}, {{-0.631782,-0.775146,0},{0,0,1}}, true },
        { "Land_HBarrier_01_line_1_green_F", {2023.11,10659.8,0.0416093}, {{-0.593392,-0.804542,-0.024451},{-0.0771034,0.0265777,0.996669}}, true },
        { "Land_HBarrier_01_line_1_green_F", {2023.57,10666,0.0417771}, {{-0.630028,-0.776447,-0.0139568},{-0.0744596,0.0425093,0.996318}}, true },
        { "Land_HBarrier_01_line_1_green_F", {2023.6,10666,1.15765}, {{-0.631782,-0.775146,0},{0,0,1}}, true },
        { "Land_HBarrier_01_line_1_green_F", {2021.72,10665.3,0.0411954}, {{0.974446,0.215421,0.0636338},{-0.0744596,0.0425093,0.996318}}, true },
        { "Land_HBarrier_01_line_1_green_F", {2024.56,10667,0.0413957}, {{-0.630885,-0.775713,0.0159293},{-0.0532575,0.0637782,0.996542}}, true },
        { "Land_HBarrier_01_line_1_green_F", {2021.73,10665.2,1.24466}, {{0.977117,0.212286,0.0133301},{-0.00923216,-0.0202837,0.999752}}, true },
        { "Land_Razorwire_F", {2011.71,10681.3,-0.0506768}, {{0.447867,-0.893522,0.0321467},{0.0133313,0.0426238,0.999002}}, true },
        { "Land_Razorwire_F", {2018.59,10680,0.143998}, {{-0.784779,-0.619699,-0.00976378},{-0.0585655,0.058465,0.99657}}, true },
        { "ProtectionZone_Invisible_F", {2040.6,10679.2,0.0189996}, {{0,0.997023,-0.0771034},{0.0452867,0.0770243,0.996}}, true },
        { "Land_Razorwire_F", {2066.17,10723.7,-0.0079422}, {{0.446993,-0.884303,-0.134929},{0.0638697,-0.118902,0.99085}}, true },
        { "Land_Razorwire_F", {2062.18,10721.7,-0.0333204}, {{0.459331,-0.864679,-0.203333},{0.11392,-0.169675,0.978894}}, true },
        { "Land_Razorwire_F", {2092.83,10709.7,0.206044}, {{-0.970284,-0.241099,-0.0204909},{-0.0479448,0.108561,0.992933}}, true },
        { "Land_Razorwire_F", {2093.92,10702.1,0.222802}, {{-0.99708,0.0286685,-0.0707832},{-0.0665191,0.129278,0.989375}}, true },
        { "Land_Razorwire_F", {2073.12,10685,0.115961}, {{0.234266,-0.962929,0.133741},{-0.0876616,0.116085,0.989363}}, true },
        { "Land_Razorwire_F", {2080.73,10687,0.14086}, {{0.233909,-0.961,0.147533},{-0.103442,0.126283,0.986586}}, true },
        { "Land_Razorwire_F", {2088.47,10689,0.139478}, {{0.233909,-0.960213,0.15257},{-0.103442,0.131455,0.98591}}, true },
        { "Land_Razorwire_F", {2093.11,10693.8,-0.333518}, {{0.987821,-0.134444,0.0783198},{-0.0479448,0.215855,0.975248}}, true },
        { "Land_HelipadCircle_F", {2071.48,10704.3,-0.00210619}, {{-0.936689,-0.349214,-0.0257499},{-0.0452868,0.0478956,0.997825}}, true },
        { "Land_Razorwire_F", {2073.18,10727,0.122449}, {{0.375874,-0.910495,-0.172387},{0,-0.186028,0.982544}}, true },
        { "Land_Razorwire_F", {2080.73,10727.3,-0.0488544}, {{-0.170352,-0.975019,-0.142542},{0.0026744,-0.145114,0.989411}}, true },
        { "Land_Razorwire_F", {2091.4,10717.6,0.0276146}, {{-0.98643,-0.162834,-0.0209831},{-0.0133317,-0.0479403,0.998761}}, true },
        { "Land_Razorwire_F", {2087.72,10724.1,-0.120538}, {{-0.676026,-0.735305,-0.0481237},{0.0186626,-0.0823715,0.996427}}, true },
        // Southern Trader Camp
        { "Land_ClutterCutter_medium_F", {4875.56,5073.36,-0.00800037}, {{0.602568,0.798018,0.00894003},{0.0239934,-0.0293117,0.999282}}, true },
        { "Land_ClutterCutter_medium_F", {4878,5076.53,-0.00933361}, {{0.602433,0.798145,0.0062528},{0.031983,-0.0319666,0.998977}}, true },
        { "Land_ClutterCutter_medium_F", {4881.68,5078.86,-0.00133705}, {{0.602568,0.797497,0.0301752},{0.0239934,-0.0558961,0.998148}}, true },
        { "Land_ClutterCutter_medium_F", {4885.97,5080.65,-0.00264645}, {{0.602568,0.797646,0.025935},{0.023991,-0.0505871,0.998431}}, true },
        { "Land_ClutterCutter_medium_F", {4873.23,5074.83,-0.00800133}, {{0.602482,0.79807,0.00998314},{0.0293202,-0.0346307,0.99897}}, true },
        { "ArrowDesk_R_F", {4877.19,5071.35,-0.0310087}, {{-0.716801,0.697278,0},{0,0,1}}, true },
        { "ArrowDesk_L_F", {4870.7,5075.72,-0.0186253}, {{0.856132,-0.516757,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {4912.45,5099.11,0.0294886}, {{0.602707,0.795429,0.0635422},{0.0106693,-0.0876564,0.996094}}, true },
        { "Land_ClutterCutter_medium_F", {4909.49,5095.2,0.0243626}, {{0.601798,0.7872,0.134737},{-0.0559124,-0.126765,0.990356}}, true },
        { "Land_ClutterCutter_medium_F", {4907.48,5092.55,-0.0113258}, {{0.601707,0.798336,-0.0246558},{0.0585662,-0.0133132,0.998195}}, true },
        { "Land_ClutterCutter_medium_F", {4903.96,5087.75,0.00733089}, {{0.602722,0.797561,0.0249533},{0.00799344,-0.0373049,0.999272}}, true },
        { "Land_ClutterCutter_medium_F", {4901.7,5084.75,0.0184765}, {{0.602733,0.795652,0.0604248},{0.00533751,-0.0797441,0.996801}}, true },
        { "Land_ClutterCutter_medium_F", {4899.08,5081.18,0.00763893}, {{0.602707,0.797861,0.0127175},{0.0106641,-0.0239897,0.999655}}, true },
        { "Land_ClutterCutter_medium_F", {4890.08,5081.38,-0.00733471}, {{0.602636,0.797953,0.010026},{0.0186626,-0.0266525,0.999471}}, true },
        { "Land_ClutterCutter_medium_F", {4894.65,5082.13,-0.0100012}, {{0.602322,0.798237,0.00517259},{0.0373061,-0.0346215,0.998704}}, true },
        { "Land_ClutterCutter_medium_F", {4899.21,5084.55,0.0039959}, {{0.602739,0.796778,0.0430185},{0.00265199,-0.055912,0.998432}}, true },
        { "Land_ClutterCutter_medium_F", {4918.6,5107.55,0.0193281}, {{0.602739,0.795602,0.0610208},{-0.00267442,-0.0744583,0.997221}}, true },
        { "Land_ClutterCutter_medium_F", {4915.08,5102.72,0.00866413}, {{0.602741,0.797458,0.027645},{0,-0.0346456,0.9994}}, true },
        { "Land_ClutterCutter_medium_F", {4933.8,5127.93,0.0239954}, {{0.602123,0.795533,0.0676382},{-0.0452868,-0.0505497,0.997694}}, true },
        { "Land_ClutterCutter_medium_F", {4930.54,5123.44,0.0193291}, {{0.602568,0.796034,0.0569375},{-0.0239937,-0.053242,0.998293}}, true },
        { "Land_ClutterCutter_medium_F", {4927.1,5119.03,0.015974}, {{0.602722,0.796,0.0557758},{-0.0080009,-0.0638667,0.997926}}, true },
        { "Land_ClutterCutter_medium_F", {4924.54,5115.51,0.00599861}, {{0.602722,0.797758,0.0175824},{-0.00799344,-0.015997,0.99984}}, true },
        { "Land_ClutterCutter_medium_F", {4921.65,5111.72,-0.00399971}, {{0.602379,0.798187,-0.00598711},{0.0346456,-0.0186514,0.999226}}, true },
        { "Land_ClutterCutter_medium_F", {4946.94,5145.82,-0.00533104}, {{0.602733,0.797783,-0.0159753},{0.00532655,0.0159975,0.999858}}, true },
        { "Land_ClutterCutter_medium_F", {4942.37,5139.48,0.00440884}, {{0.601886,0.798509,-0.0108183},{0.0532574,-0.0266193,0.998226}}, true },
        { "Land_ClutterCutter_medium_F", {4939.19,5135.37,0.010684}, {{0.602741,0.797211,0.0340141},{0,-0.0426276,0.999091}}, true },
        { "Land_ClutterCutter_medium_F", {4936.26,5131.33,0}, {{0.602741,0.797937,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {4956.69,5159.28,0.0226593}, {{0.602433,0.795438,0.0659758},{-0.031983,-0.0585353,0.997773}}, true },
        { "Land_ClutterCutter_medium_F", {4953.5,5154.86,-0.00599957}, {{0.602527,0.797976,-0.0139512},{0.0266571,-0.00265105,0.999641}}, true },
        { "Land_ClutterCutter_medium_F", {4950.16,5150.25,0.0253544}, {{0.602193,0.795062,0.0723807},{-0.0426276,-0.0585121,0.997376}}, true },
        { "Land_ClutterCutter_medium_F", {4977.79,5187.71,0.0113306}, {{0.602707,0.797235,0.0340688},{-0.0106641,-0.0346436,0.999343}}, true },
        { "Land_ClutterCutter_medium_F", {4975.14,5184.07,0.0133505}, {{0.602123,0.797693,0.0336793},{-0.0452868,-0.00799238,0.998942}}, true },
        { "Land_ClutterCutter_medium_F", {4972.29,5180.63,0.00711155}, {{0.602739,0.797745,0.0175453},{0.00265199,-0.0239909,0.999709}}, true },
        { "Land_ClutterCutter_medium_F", {4969.36,5176.76,0.0139971}, {{0.602636,0.796961,0.0410104},{-0.0186628,-0.0373015,0.99913}}, true },
        { "Land_ClutterCutter_medium_F", {4967.33,5173.96,0.0113306}, {{0.60226,0.797797,0.0283397},{-0.039967,-0.00532229,0.999187}}, true },
        { "Land_ClutterCutter_medium_F", {4964.87,5170.59,0.0116978}, {{0.602322,0.796809,0.047995},{-0.0373063,-0.0319607,0.998793}}, true },
        { "Land_ClutterCutter_medium_F", {4962.2,5166.89,0.0153294}, {{0.602193,0.797318,0.0405841},{-0.042629,-0.018649,0.998917}}, true },
        { "Land_ClutterCutter_medium_F", {4959.61,5163.32,0.0166636}, {{0.602739,0.796205,0.0525719},{-0.00267442,-0.0638685,0.997955}}, true },
        { "Land_ClutterCutter_medium_F", {4969.53,5189.9,0.0431604}, {{0.601707,0.79258,0.0988191},{-0.0585655,-0.0796084,0.995104}}, true },
        { "Land_ClutterCutter_medium_F", {4973.41,5187.44,0.0446777}, {{0.602123,0.793219,0.0908402},{-0.0452868,-0.0796625,0.995793}}, true },
        { "Land_ClutterCutter_medium_F", {4970.58,5183.01,0.00935173}, {{0.602739,0.797844,-0.0122361},{0.00265199,0.0133316,0.999908}}, true },
        { "Land_ClutterCutter_medium_F", {4967.68,5185.26,0.00202084}, {{0.602433,0.797609,-0.0299136},{0.031983,0.0133248,0.9994}}, true },
        { "Land_ClutterCutter_large_F", {5006.19,5219.31,9.82285e-005}, {{0,0.999304,-0.0373063},{-0.0293202,0.0372903,0.998874}}, true },
        { "Land_ClutterCutter_medium_F", {5000.25,5215.34,-0.0639887}, {{0,0.99615,-0.0876609},{0.037308,0.0875999,0.995457}}, true },
        { "Land_ClutterCutter_medium_F", {4997.36,5212.14,-0.038662}, {{0,0.999968,-0.00799344},{0.0159975,0.00799242,0.99984}}, true },
        { "Land_ClutterCutter_medium_F", {4994.27,5208.74,-9.53674e-007}, {{0.602636,0.797655,-0.0240124},{0.0186626,0.0159949,0.999698}}, true },
        { "Land_ClutterCutter_medium_F", {4991.76,5205.2,-0.00333309}, {{0.602722,0.7979,-0.00907243},{0.00800059,0.00532633,0.999954}}, true },
        { "Land_ClutterCutter_medium_F", {4988.74,5201.16,-0.0136147}, {{0.602193,0.796567,-0.053323},{0.0426276,0.0346141,0.998491}}, true },
        { "Land_ClutterCutter_medium_F", {4986.65,5197.79,-0.00598907}, {{0.602123,0.798337,-0.0102723},{0.0452867,-0.0213053,0.998747}}, true },
        { "Land_ClutterCutter_medium_F", {4983.53,5194.69,0.015708}, {{0.60226,0.797129,0.0432289},{-0.0399685,-0.0239742,0.998913}}, true },
        { "Land_ClutterCutter_medium_F", {4980.45,5191.35,0.0140123}, {{0.602604,0.797012,0.0404921},{-0.0213272,-0.0346377,0.999172}}, true },
        { "Land_GarbageContainer_closed_F", {5033.58,5206.82,0.459593}, {{-0.892229,0.451583,0},{0,0,1}}, true },
        { "Land_PCSet_01_case_F", {5029.58,5210.44,0.422398}, {{0.460556,0.887631,6.17034e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Laptop_unfolded_F", {5028.99,5210.8,1.19744}, {{-0.473411,-0.880841,-8.52232e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Laptop_device_F", {5028.45,5210.93,1.18959}, {{-0.0237867,-0.999717,0.000655495},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_ClutterCutter_medium_F", {5014.25,5203.64,2.86102e-006}, {{0,0.998436,-0.0559124},{0.0559122,0.055825,0.996874}}, true },
        { "Land_ClutterCutter_medium_F", {5031.64,5209.68,2.86102e-006}, {{0,0.999943,-0.0106641},{0.047947,0.0106518,0.998793}}, true },
        { "Land_ClutterCutter_medium_F", {5020.63,5211.65,2.86102e-006}, {{0,0.999911,-0.0133317},{0.0133313,0.0133305,0.999822}}, true },
        { "Land_ClutterCutter_medium_F", {5024.21,5210.86,2.86102e-006}, {{0,0.999488,-0.031983},{0.0823858,0.0318743,0.996091}}, true },
        { "Land_ClutterCutter_medium_F", {5021.08,5208.79,2.86102e-006}, {{0,0.999826,-0.018666},{0.018666,0.0186627,0.999652}}, true },
        { "Land_ClutterCutter_medium_F", {5018.24,5206.74,2.86102e-006}, {{0,0.999996,-0.00265204},{-0.0080009,0.00265196,0.999964}}, true },
        { "Land_ClutterCutter_medium_F", {5027.12,5217.84,2.86102e-006}, {{0,0.997958,-0.0638688},{0.0559122,0.0637689,0.996397}}, true },
        { "Land_ClutterCutter_medium_F", {5022.52,5215.4,2.86102e-006}, {{0,0.999996,-0.00267442},{-0.0186628,0.00267396,0.999822}}, true },
        { "Land_ClutterCutter_medium_F", {5016.34,5209.67,2.86102e-006}, {{0,0.999826,-0.0186628},{0.0159975,0.0186604,0.999698}}, true },
        { "Land_ClutterCutter_medium_F", {5035.41,5210.38,2.86102e-006}, {{0,0.998581,-0.0532575},{0.0106641,0.0532545,0.998524}}, true },
        { "Land_ClutterCutter_medium_F", {5024.85,5204.84,-0.0242786}, {{0,0.99615,-0.0876609},{0.0532574,0.0875365,0.994737}}, true },
        { "Land_ClutterCutter_medium_F", {5018.88,5200.97,2.86102e-006}, {{0,0.889825,0.456303},{0.718115,-0.317552,0.619251}}, true },
        { "Land_ClutterCutter_medium_F", {5023.95,5207.99,2.86102e-006}, {{0,0.999201,-0.0399685},{0.0638687,0.0398869,0.997161}}, true },
        { "Land_ClutterCutter_medium_F", {5027.88,5207.77,2.86102e-006}, {{0,0.997958,-0.0638688},{0.0106693,0.0638652,0.997901}}, true },
        { "Land_ClutterCutter_medium_F", {5019.85,5205.33,2.86102e-006}, {{0,0.999996,-0.00265204},{-0.0080009,0.00265196,0.999964}}, true },
        { "Land_ClutterCutter_medium_F", {5033.72,5213.95,2.86102e-006}, {{0,0.997224,-0.0744596},{0.0106693,0.0744553,0.997167}}, true },
        { "Land_ClutterCutter_medium_F", {5030.44,5213.59,2.86102e-006}, {{0,0.997605,-0.0691671},{0.0426276,0.0691043,0.996698}}, true },
        { "Land_ClutterCutter_medium_F", {5012.85,5216.94,-0.0164127}, {{0,0.995915,-0.0902964},{0.069167,0.0900801,0.99353}}, true },
        { "Land_ClutterCutter_medium_F", {5014.14,5213.29,-0.0326633}, {{0,0.99349,-0.113921},{0.0159975,0.113906,0.993363}}, true },
        { "Land_ClutterCutter_medium_F", {5016.79,5215.35,-0.0220337}, {{0,0.995673,-0.0929294},{-0.0053265,0.0929281,0.995659}}, true },
        { "Land_ClutterCutter_medium_F", {5015.13,5198.68,0.00800133}, {{0,0.999773,0.0213271},{-0.0106641,-0.0213259,0.999716}}, true },
        { "Land_ClutterCutter_medium_F", {5026.9,5212.59,2.86102e-006}, {{0,0.999996,-0.00265204},{-0.0106641,0.00265189,0.99994}}, true },
        { "Land_CampingTable_F", {5032.32,5208.81,0.542001}, {{-0.472442,-0.881361,-8.34449e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_CampingTable_F", {5029.01,5210.66,0.383964}, {{-0.472442,-0.881361,-8.34449e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_WeldingTrolley_01_F", {5027.78,5207.2,0.240896}, {{0.403332,0.915053,-4.10559e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_ToolTrolley_02_F", {5027.46,5211.78,0.394034}, {{-0.907383,0.420302,-0.00161941},{-0.00146484,0.000690533,0.999999}}, true },
        { "WaterPump_01_forest_F", {5025.69,5207.27,0.238022}, {{0.922392,-0.38625,0.00161788},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_CampingTable_small_F", {5018.61,5198.62,-0.00429916}, {{0,0.998974,-0.0452868},{0.0026744,0.0452867,0.99897}}, true },
        { "Land_FieldToilet_F", {5014.29,5197.52,-0.0072279}, {{-0.839531,-0.542666,-0.0264603},{-0.0159977,-0.0239903,0.999584}}, true },
        { "Land_FieldToilet_F", {5015.17,5196.13,-0.0046978}, {{-0.839531,-0.542666,-0.0264603},{-0.0159977,-0.0239903,0.999584}}, true },
        { "Land_WaterTank_F", {5025.5,5209.96,0.349309}, {{0.898363,-0.439251,0.00161928},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_ToolTrolley_01_F", {5010.98,5210.33,0.00155735}, {{-0.560359,-0.824208,0.081724},{0.0319849,0.0770631,0.996513}}, true },
        { "Land_CanisterFuel_F", {5032.14,5208.95,0.535025}, {{0.878454,-0.477825,0.00161675},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_CanisterFuel_F", {5031.97,5209.02,0.527202}, {{0.878454,-0.477825,0.00161675},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Wrench_F", {5032.11,5208.77,1.34455}, {{0,1,-0.000690534},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Pliers_F", {5032,5208.86,1.33989}, {{0.391919,0.92,-6.119e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Ammobox_rounds_F", {5031.82,5209.1,1.33417}, {{0.449007,0.893528,4.07134e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Ammobox_rounds_F", {5031.73,5208.94,1.32801}, {{0.449007,0.893528,4.07134e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Ammobox_rounds_F", {5031.91,5209.26,1.34035}, {{0.449007,0.893528,4.07134e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Magazine_rifle_F", {5032.28,5209.09,1.35119}, {{0.490736,0.871308,0.000117184},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Magazine_rifle_F", {5032.16,5209.02,1.34682}, {{0.490736,0.871308,0.000117184},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Magazine_rifle_F", {5032.28,5209.08,1.36953}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.14,5209.17,1.38291}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.22,5209.15,1.36953}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.22,5209.15,1.3874}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.22,5209.15,1.35119}, {{0.490736,0.871308,0.000117184},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Magazine_rifle_F", {5032.22,5208.96,1.35157}, {{0.490172,0.871008,-0.0328185},{0.0479446,0.0106518,0.998793}}, true },
        { "Land_Magazine_rifle_F", {5032.16,5209.01,1.36578}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.14,5209.17,1.36516}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.15,5209.17,1.34682}, {{0.490736,0.871308,0.000117184},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Magazine_rifle_F", {5032.09,5209.06,1.36467}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.1,5209.05,1.34633}, {{0.490736,0.871308,0.000117184},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Magazine_rifle_F", {5032.16,5209.02,1.3839}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_Magazine_rifle_F", {5032.09,5209.05,1.38249}, {{0.490736,0.871308,0},{0,0,1}}, true },
        { "Land_GasTank_01_khaki_F", {5031.77,5209.28,0.520709}, {{-0.514783,-0.85732,-0.000162069},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_PortableSpeakers_01_F", {5031.66,5209.46,1.3303}, {{0.924452,0.381297,0.00109088},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Tablet_02_F", {5028.77,5210.58,1.1844}, {{-0.448944,-0.89356,-4.06002e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_SatelliteAntenna_01_F", {5025.15,5216.25,0.436687}, {{-0.530084,0.847944,-0.00136202},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_CampingChair_V1_F", {5015.93,5200.23,0.00102806}, {{-0.774672,-0.628261,0.0719073},{0.0559122,0.045216,0.997411}}, true },
        { "Land_CampingChair_V1_F", {5019.69,5200,0.000600815}, {{0.936153,-0.351591,-0.000647001},{0.0266571,0.0691426,0.997251}}, true },
        { "Land_CampingChair_V1_F", {5017.1,5199.44,0.00129986}, {{-0.438246,-0.896487,0.0652076},{0.0559122,0.045216,0.997411}}, true },
        { "Land_HelipadCircle_F", {4961.36,5191.7,0}, {{-0.427476,-0.903535,-0.0297957},{-0.0133317,-0.0266547,0.999556}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5008.34,5201.13,0.00773048}, {{0.811849,0.578219,-0.0810134},{0.0559122,0.0611232,0.996563}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5005.47,5207.89,-0.00196171}, {{-0.988344,-0.146947,0.0397721},{0.0346456,0.0372839,0.998704}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5007.71,5213.48,0.00213528}, {{-0.634543,0.771827,-0.040472},{0.071814,0.111017,0.99122}}, true },
        { "ProtectionZone_Invisible_F", {4995.14,5201.25,0.00053978}, {{0,0.999943,0.0106641},{0.0106641,-0.0106635,0.999886}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5006.32,5227.11,0.0114241}, {{0.329441,0.942128,-0.0621498},{-0.0399685,0.0796809,0.996019}}, true },
        { "Land_Trench_01_grass_F", {5018.82,5179.14,-0.0419836}, {{0.466524,0.884509,0},{0,0,1}}, true },
        { "Land_Trench_01_grass_F", {5021.98,5177.78,-0.00653362}, {{0.466524,0.884509,0},{0,0,1}}, true },
        { "Land_Trench_01_grass_F", {5019.78,5174.84,0.0133362}, {{0.466524,0.884509,0},{0,0,1}}, true },
        { "Land_Trench_01_grass_F", {5017.02,5176.27,-0.0733452}, {{0.466524,0.884509,0},{0,0,1}}, true },
        { "Land_CrabCages_F", {5031.22,5201.67,0.061182}, {{0.500948,0.865477,0.00013617},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Trench_01_grass_F", {5030.29,5213.15,0.000412941}, {{0.376095,0.926581,0},{0,0,1}}, true },
        { "Land_Trench_01_grass_F", {5033.39,5211.69,-0.0157623}, {{0.376095,0.926581,0},{0,0,1}}, true },
        { "Land_Trench_01_grass_F", {5036.23,5210.42,-0.0286341}, {{0.376095,0.926581,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5034.61,5202.57,0.0100193}, {{0.923972,-0.382059,-0.0175207},{0.0452867,0.0638033,0.996934}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5038.31,5214.93,-0.00209045}, {{-0.983292,0.181567,0.013036},{0.0186626,0.0293151,0.999396}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5030.71,5197.99,-0.0630207}, {{0.487846,-0.872929,0.00131741},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5036.89,5208.68,-0.00261402}, {{-0.949739,0.312198,0.0229965},{0.0373061,0.0399392,0.998505}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5025.63,5194.95,0.00261211}, {{0.533511,-0.845767,0.00665939},{0.02133,0.0213252,0.999545}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5019.3,5192.55,0.000221252}, {{0.254755,-0.9668,-0.0199423},{-0.00267442,-0.0213271,0.999769}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5013.62,5194.4,0.00361443}, {{0.811174,0.580577,-0.0701923},{0.069168,0.0239362,0.997318}}, true },
        { "Land_Atm_01_F", {5026.35,5211.96,0.420522}, {{0.898794,-0.438371,0},{0,0,1}}, true },
        { "Land_HBarrier_01_line_1_green_F", {5012.5,5217.71,0.000192642}, {{-0.598347,0.801108,-0.0143817},{-0.0133317,0.00799273,0.999879}}, true },
        { "Land_Campfire_F", {5017.94,5201,-0.000110626}, {{0,0.997605,-0.0691671},{0.0266571,0.0691426,0.997251}}, false},
        { "Land_DataTerminal_01_F", {5028.82,5210.85,0.389002}, {{0.46898,0.883209,7.70965e-005},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_PaperBox_closed_F", {5035.39,5210.99,0.52301}, {{-0.883528,0.468376,-0.00161766},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_Scrap_MRAP_01_F", {5012.29,5208,0.000803947}, {{-0.31418,-0.948796,0.0328258},{0.031983,0.023979,0.999201}}, true },
        { "Land_Pallet_MilBoxes_F", {5034.42,5208.93,0.482203}, {{-0.884246,0.467018,-0.00161778},{-0.00146484,0.000690533,0.999999}}, true },
        { "Land_PartyTent_01_F", {5030.12,5209.09,0.463215}, {{0.43478,0.900537,0},{0,0,1}}, true },
        { "Land_WoodPile_F", {5020.4,5201.95,0.00334358}, {{-0.636255,0.771388,-0.0118191},{0.0266571,0.0372931,0.998949}}, true },
        { "Land_Pier_F", {5020.31,5196.47,-2.59}, {{-0.894755,0.446557,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_tower_green_F", {5022.42,5222.93,0.065362}, {{-0.481998,-0.876173,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5020.01,5224.19,-0.000741005}, {{-0.634279,0.772348,-0.0341766},{0.0239934,0.0638514,0.997671}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5027.76,5228.37,-1.2022}, {{-0.33662,0.941624,-0.00562072},{0.0638701,0.0287874,0.997543}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5034.95,5227.66,-1.572}, {{0.487311,0.873228,0},{0,0,1}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5038.28,5221.87,-1.0691}, {{0.983901,0.174494,-0.0386204},{0,0.216099,0.976372}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5017.46,5222.1,0.00150108}, {{-0.634453,0.770605,-0.060305},{0.00533751,0.0823839,0.996586}}, true },
        { "Land_HBarrier_01_big_4_green_F", {5012.98,5222.69,-0.000469208}, {{0.703539,0.701686,-0.112563},{0.0452867,0.113804,0.992471}}, true },
        //Northern Trader Camp
        { "Land_ClutterCutter_medium_F", {11457.6,13203.4,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11452.1,13204.9,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11447.7,13206.1,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11442.4,13207.5,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11482.2,13196.6,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11476.7,13198.3,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11470.5,13199.9,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11464.2,13201.8,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11504,13190.4,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11494.4,13193.1,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11537.8,13142.8,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11541.3,13156,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11545.5,13166.5,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11543.1,13161.4,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11547.1,13171.5,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11544.5,13178.4,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11532,13182,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11526.4,13183.8,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11520.5,13185.1,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11659.8,13096.2,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11655.8,13098.3,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11651.4,13100,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11647.2,13102.1,0}, {{0.941709,-0.336429,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11678.7,13090.2,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11671.1,13092.5,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11712.7,13078.6,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11720.9,13107.4,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11721.8,13099.1,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11706.5,13080,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11727,13125.9,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11721.5,13127.6,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11717.1,13123.4,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11715.6,13118.6,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11759.7,13069.9,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11751.4,13099.7,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11748.1,13104.2,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11745.2,13107.9,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11755.2,13095,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11758.2,13090.8,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11742.2,13111.8,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11738.1,13116.6,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11731,13125.2,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_Cargo20_military_green_F", {11789,13040.2,2.68044}, {{-0.961844,0.273596,0.00105012},{0.00109178,0,0.999999}}, true },
        { "Land_Cargo20_military_green_F", {11789,13040.1,0.0454512}, {{-0.961844,0.273596,0.00105012},{0.00109178,0,0.999999}}, true },
        { "Land_Cargo20_military_green_F", {11786.5,13040.9,0.048193}, {{-0.961844,0.273596,0.00105012},{0.00109178,0,0.999999}}, true },
        { "Land_JetEngineStarter_01_F", {11775,13043.7,0.0540004}, {{-0.248318,-0.968679,0.000273004},{0.00109941,0,0.999999}}, true },
        { "Land_Cargo10_red_F", {11782.7,13040.8,0.0440102}, {{0.970054,-0.242887,-0.00106649},{0.00109941,0,0.999999}}, true },
        { "Land_WoodenCart_F", {11786.1,13048.6,0.0489998}, {{0.837852,-0.545897,-0.000921144},{0.00109941,0,0.999999}}, true },
        { "Land_PalletTrolley_01_yellow_F", {11789.7,13043.9,0.0447292}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_GarbageContainer_closed_F", {11770.8,13042.2,0.0650001}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "WaterPump_01_forest_F", {11784.7,13043.5,0.0500002}, {{-0.102393,-0.994744,0.000112572},{0.00109941,0,0.999999}}, true },
        { "Land_PCSet_01_case_F", {11789.8,13063.1,0.04461}, {{-0.973638,0.228096,0.001063},{0.00109178,0,0.999999}}, true },
        { "Land_WaterCooler_01_new_F", {11788.7,13058.8,0.046}, {{-0.255716,-0.966752,0.000281137},{0.00109941,0,0.999999}}, true },
        { "Land_Laptop_device_F", {11789.9,13063.2,0.857732}, {{0.582931,-0.812521,-0.000636434},{0.00109178,0,0.999999}}, true },
        { "Land_Laptop_device_F", {11789.5,13062.8,0.858178}, {{0.963863,-0.266397,-0.00105233},{0.00109178,0,0.999999}}, true },
        { "Land_ClutterCutter_medium_F", {11760.6,13075.1,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_CampingTable_F", {11789.6,13062.6,0.0448422}, {{0.965925,-0.258819,-0.00105458},{0.00109178,0,0.999999}}, true },
        { "Land_CampingTable_F", {11787.1,13052.8,0.0475454}, {{0.965925,-0.258819,-0.00105458},{0.00109178,0,0.999999}}, true },
        { "Land_CampingTable_F", {11788.4,13057.6,0.0461092}, {{0.965926,-0.258819,0},{0,0,1}}, true },
        { "Land_TripodScreen_01_dual_v2_F", {11789,13061.4,0.0455351}, {{0.862697,0.50572,-0.000941878},{0.00109178,0,0.999999}}, true },
        { "Land_FieldToilet_F", {11767.9,13058.1,0.0684881}, {{-0.966137,0.258029,0.00105481},{0.00109178,0,0.999999}}, true },
        { "Land_FieldToilet_F", {11768.5,13060.4,0.0659962}, {{-0.966137,0.258029,0.00105481},{0.00109178,0,0.999999}}, true },
        { "Land_FieldToilet_F", {11768.2,13059.3,0.0672598}, {{-0.966137,0.258029,0.00105481},{0.00109178,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.4,13053.6,0.86}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.6,13053.5,0.859724}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.3,13053.6,0.85996}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.3,13053.6,0.860057}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.2,13053.7,0.860155}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.1,13053.7,0.860594}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.5,13053.4,0.860086}, {{0,1,0},{0,0,1}}, true },
        { "Land_BottlePlastic_V2_F", {11787.4,13053.5,0.860269}, {{0,1,0},{0,0,1}}, true },
        { "Land_BottlePlastic_V2_F", {11787.3,13053.5,0.860304}, {{0,1,0},{0,0,1}}, true },
        { "Land_BottlePlastic_V2_F", {11787.2,13053.5,0.860404}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787.1,13053.5,0.860502}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11787,13053.6,0.860614}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.5,13053.3,0.860138}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.4,13053.3,0.860196}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.3,13053.4,0.860277}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.3,13053.4,0.860333}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.2,13053.4,0.860445}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.2,13053.3,0.860379}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.3,13053.3,0.860276}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.4,13053.3,0.860153}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.4,13053.2,0.860198}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.3,13053.3,0.860382}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.2,13053.3,0.860442}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.1,13053.3,0.860498}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.1,13053.4,0.860531}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787,13053.4,0.86059}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787,13053.3,0.860598}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.1,13053.3,0.8605}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11787.3,13053.2,0.860266}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_RiceBox_F", {11786.9,13052.9,0.861}, {{0.990726,-0.135871,-0.00108922},{0.00109941,0,0.999999}}, true },
        { "Land_RiceBox_F", {11787.3,13052.7,0.860408}, {{0.990726,-0.135871,-0.00108166},{0.00109178,0,0.999999}}, true },
        { "Land_RiceBox_F", {11787.2,13052.8,0.860452}, {{0.990726,-0.135871,-0.00108166},{0.00109178,0,0.999999}}, true },
        { "Land_RiceBox_F", {11787,13052.8,0.860608}, {{0.990726,-0.135871,-0.00108166},{0.00109178,0,0.999999}}, true },
        { "Land_RiceBox_F", {11787.3,13052.8,0.860398}, {{0.990726,-0.135871,-0.00108166},{0.00109178,0,0.999999}}, true },
        { "Land_RiceBox_F", {11787.2,13052.9,0.860448}, {{0.990726,-0.135871,-0.00108166},{0.00109178,0,0.999999}}, true },
        { "Land_RiceBox_F", {11787,13052.9,0.860722}, {{0.990726,-0.135871,-0.00108166},{0.00109178,0,0.999999}}, true },
        { "Land_RiceBox_F", {11786.9,13053,0.860888}, {{0.990726,-0.135871,-0.00108166},{0.00109178,0,0.999999}}, true },
        { "Land_MobileScafolding_01_F", {11778.4,13055.9,0.0570002}, {{0.763796,0.645458,-0.000839726},{0.00109941,0,0.999999}}, true },
        { "Land_MobileScafolding_01_F", {11780.6,13050.6,0.0546398}, {{0.999684,-0.0251029,-0.00109144},{0.00109178,0,0.999999}}, true },
        { "Land_ButaneTorch_F", {11777.2,13056.8,1.738}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_GasTank_01_yellow_F", {11777.5,13057,0.0580001}, {{-0.810072,-0.58633,0.000890603},{0.00109941,0,0.999999}}, true },
        { "Land_ToolTrolley_02_F", {11778.2,13056.3,0.0570002}, {{0.90335,-0.428904,-0.000993154},{0.00109941,0,0.999999}}, true },
        { "Land_WeldingTrolley_01_F", {11779.2,13055,0.0560002}, {{-0.582137,0.813091,0.000640008},{0.00109941,0,0.999999}}, true },
        { "Land_ClutterCutter_medium_F", {11761.4,13086.4,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11762,13081.9,0}, {{0.980684,-0.195597,0},{0,0,1}}, true },
        { "Land_Cargo20_military_green_F", {11791.5,13039.5,2.67775}, {{-0.961844,0.273596,0.00105012},{0.00109178,0,0.999999}}, true },
        { "Land_Cargo20_military_green_F", {11791.5,13039.4,0.0427685}, {{-0.961844,0.273596,0.00105012},{0.00109178,0,0.999999}}, true },
        { "Land_KartStand_01_F", {11791.2,13047.4,0.0430002}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_Portable_generator_F", {11792,13062.5,0.0422258}, {{-0.237024,-0.971504,0.000258778},{0.00109178,0,0.999999}}, true },
        { "Land_TacticalBacon_F", {11792.1,13064.4,0.813005}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_BottlePlastic_V2_F", {11792.1,13064.3,0.813012}, {{0,1,0},{0,0,1}}, true },
        { "Land_BottlePlastic_V2_F", {11792.1,13064.4,0.839183}, {{0,-4.37114e-008,-1},{0,1,-4.37114e-008}}, true },
        { "Land_CampingChair_V2_F", {11791.1,13065.9,0}, {{-0.964884,-0.262678,0},{0,0,1}}, true },
        { "Land_CampingChair_V2_F", {11793.7,13064.2,0}, {{0.434194,-0.90082,0},{0,0,1}}, true },
        { "Land_CampingChair_V2_F", {11791.3,13064.7,0}, {{-0.787892,-0.615813,0},{0,0,1}}, true },
        { "Land_CampingTable_small_F", {11792.4,13064.3,0}, {{0.2208,0.975319,0},{0,0,1}}, true },
        { "Land_DieselGroundPowerUnit_01_F", {11792.5,13055.3,0.0419998}, {{0,1,0},{0.00109941,0,0.999999}}, true },
        { "Land_PressureWasher_01_F", {11791.2,13055.3,0.0430002}, {{0.997338,0.0729075,-0.00109649},{0.00109941,0,0.999999}}, true },
        { "Land_ClutterCutter_medium_F", {11874.5,13048.9,0}, {{0,1,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11867.6,13049.1,0}, {{0,1,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11860.9,13049.4,0}, {{0,1,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11852.8,13049.5,0}, {{0,1,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11878.9,13049.2,0}, {{0,1,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11889.5,13047.9,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11896.4,13045.3,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11901.9,13043.8,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11904.8,13045.1,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11907.2,13052.1,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11919.5,13070.7,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11926.4,13068.4,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11940,13065.2,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11948.8,13062.2,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11953.4,13060.6,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11963.3,13057.7,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {11980,13052.9,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12008.1,13044.7,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12095.6,13018.4,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12102,13016.6,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12127,13009.4,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12166,12979.5,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12168.4,12975.3,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12168.7,12968.5,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12161.9,12987.6,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12163.9,12983,0}, {{0.531672,-0.846951,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12155.8,12999.7,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_ClutterCutter_medium_F", {12158.7,12993.2,0}, {{0.956847,-0.290591,0},{0,0,1}}, true },
        { "Land_PortableLight_double_F", {11781.9,13043.6,0.102902}, {{-0.750186,-0.661227,0},{0,0,1}}, false },
        { "Land_PortableLight_double_F", {11772.5,13041.9,0.0970407}, {{0.0740564,-0.997254,0},{0,0,1}}, false },
        { "Land_Scrap_MRAP_01_F", {11767,13046.1,0.0691104}, {{-0.943564,-0.33119,0.00103737},{0.00109941,0,0.999999}}, true },
        { "Land_Device_assembled_F", {11778.5,13041.2,0.0289407}, {{-0.960812,0.277197,0.00105633},{0.00109941,0,0.999999}}, true },
        { "Land_ScrapHeap_1_F", {11766.8,13050,0.0691848}, {{0.903529,0.428525,-0.000986458},{0.00109178,0,0.999999}}, true },
        { "Land_Sacks_heap_F", {11787,13047.9,1.09401}, {{-0.669737,0.696034,-0.25882},{-0.222757,0.14418,0.964153}}, true },
        { "Land_GuardRailing_01_F", {11782,13067,0}, {{-0.952161,0.305596,0},{0,0,1}}, true },
        { "Land_GuardRailing_01_F", {11787.4,13065.5,0}, {{-0.952161,0.305596,0},{0,0,1}}, true },
        { "Land_BackAlley_01_l_gate_F", {11784.3,13065.2,0.0510001}, {{0.263031,0.964787,0},{0,0,1}}, false },
        { "Land_Atm_01_F", {11788,13055.8,0}, {{0.964787,-0.263031,0},{0,0,1}}, true },
        { "Land_DataTerminal_01_F", {11789.6,13062.3,0.0448132}, {{-0.966568,0.256407,0.00105528},{0.00109178,0,0.999999}}, true },
        { "Land_Wreck_Heli_Attack_02_F", {11778.3,13052.6,0.0581093}, {{0.395257,-0.918571,-0.00043455},{0.00109941,0,0.999999}}, true },
        { "Land_PortableLight_double_F", {11784.5,13062.8,0.0500007}, {{-0.639157,0.769076,0},{0,0,1}}, false },
        { "Land_PortableLight_double_F", {11770,13068.5,0.0662217}, {{-0.639157,0.769076,0},{0,0,1}}, false },
        { "Land_PortableLight_double_F", {11782.8,13063.4,0.0522637}, {{0.940598,0.339523,0},{0,0,1}}, false },
        { "Land_ScrapHeap_2_F", {11767.1,13053.5,0.0697136}, {{0.273153,0.961971,-0.000298224},{0.00109178,0,0.999999}}, true },
        { "Land_GymRack_01_F", {11769.2,13063,0.0670271}, {{-0.956656,0.29122,0.00105176},{0.00109941,0,0.999999}}, true },
        { "Land_GymBench_01_F", {11771.6,13067.3,0.0639992}, {{0.278907,0.960318,-0.000306634},{0.00109941,0,0.999999}}, true },
        { "Land_GymRack_02_F", {11769.1,13066.3,0.0670094}, {{-0.970012,0.243056,0.00106644},{0.00109941,0,0.999999}}, true },
        { "Land_GymRack_03_F", {11774,13067.5,0.0618873}, {{0.2471,0.96899,-0.00026978},{0.00109178,0,0.999999}}, true },
        { "Land_CratesPlastic_F", {11787,13052.2,0.86069}, {{-0.96923,0.246154,0.00105819},{0.00109178,0,0.999999}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11778.7,13066.8,-0.193257}, {{0.267238,0.96363,0},{0,0,1}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11785,13066.9,-0.25}, {{0.263031,0.964787,0},{0,0,1}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11789.9,13063.7,-0.206364}, {{0.267238,0.96363,0},{0,0,1}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11787,13064.5,-0.203082}, {{0.267238,0.96363,0},{0,0,1}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11781.6,13066,-0.196193}, {{0.267238,0.96363,0},{0,0,1}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11783.9,13063.7,-0.199733}, {{0.267238,0.96363,0},{0,0,1}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11776,13067.6,-0.19016}, {{0.267238,0.96363,0},{0,0,1}}, true },
        { "Land_Sack_F", {11788.4,13053.9,0.0461245}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_Sacks_goods_F", {11787.6,13054.3,0.0470386}, {{-0.775859,0.630906,0.000847069},{0.00109178,0,0.999999}}, true },
        { "Land_StallWater_F", {11787.2,13050.8,0.0474386}, {{0.963563,-0.267479,-0.001052},{0.00109178,0,0.999999}}, true },
        { "Land_CrabCages_F", {11793.3,13047.5,0.0418329}, {{-0.973479,0.228776,0.00106283},{0.00109178,0,0.999999}}, true },
        { "Land_PaperBox_closed_F", {11792.8,13043.2,1.27933}, {{0.299021,0.953592,-0.0353304},{0.0115648,0.0334002,0.999375}}, true },
        { "Land_PaperBox_closed_F", {11793.3,13044.6,0.0411615}, {{0.299041,0.95424,-0.000326487},{0.00109178,0,0.999999}}, true },
        { "Land_PaperBox_closed_F", {11792.8,13043.2,0.0412612}, {{0.299041,0.95424,-0.000326487},{0.00109178,0,0.999999}}, true },
        { "Land_PaperBox_closed_F", {11791.4,13043.6,0.0428081}, {{0.299041,0.95424,-0.000326487},{0.00109178,0,0.999999}}, true },
        { "Land_PaperBox_closed_F", {11793.3,13044.6,1.27985}, {{0.29893,0.953601,-0.03585},{-0.0272342,0.0460777,0.998567}}, true },
        { "Land_PaperBox_closed_F", {11791.4,13043.6,1.28312}, {{0.29893,0.953601,-0.03585},{-0.0272342,0.0460777,0.998567}}, true },
        { "Land_PaperBox_open_full_F", {11791.8,13045,0.0419908}, {{-0.957278,0.289166,0.00105244},{0.00109941,0,0.999999}}, true },
        { "Land_WoodenCrate_01_stack_x3_F", {11796.2,13060.5,0.0377216}, {{0,1,0},{0.00109178,0,0.999999}}, true },
        { "Land_WoodenCrate_01_stack_x5_F", {11797.6,13060.3,0.0361176}, {{0.973195,-0.229977,-0.00106252},{0.00109178,0,0.999999}}, true },
        { "Land_WoodenCrate_01_stack_x5_F", {11797.2,13058.6,0.0364685}, {{-0.977819,0.209448,0.00106757},{0.00109178,0,0.999999}}, true },
        { "Land_Campfire_F", {11792.8,13065.8,0}, {{0,1,0},{0,0,1}}, false },
        { "Land_PortableLight_double_F", {11795.1,13061.6,0.0388217}, {{0.932382,0.361475,0},{0,0,1}}, false },
        { "Land_Cages_F", {11796.1,13055.2,0.0374999}, {{-0.194422,-0.980918,0.000212267},{0.00109178,0,0.999999}}, true },
        { "Land_Cages_F", {11795.8,13053.7,0.0374999}, {{-0.194422,-0.980918,0.000212267},{0.00109178,0,0.999999}}, true },
        { "Land_Wall_IndCnc_2deco_F", {11792.7,13062.9,-0.25}, {{0.267238,0.96363,0},{0,0,1}}, true },
        { "Land_Sacks_heap_F", {11795.3,13052,0.0386171}, {{-0.686998,0.726659,0.000750053},{0.00109178,0,0.999999}}, true },
        { "Land_Sacks_heap_F", {11795.2,13051.4,0.0386615}, {{0.999998,-0.00192801,-0.00109178},{0.00109178,0,0.999999}}, true },
        { "Land_Sacks_heap_F", {11795.1,13050.4,0.0388002}, {{0.205024,0.978757,-0.000223842},{0.00109178,0,0.999999}}, true },
        { "Land_CratesShabby_F", {11796.6,13056.7,0.0369964}, {{-0.973384,0.229177,0.00106272},{0.00109178,0,0.999999}}, true },
        { "Land_CratesShabby_F", {11796.8,13057.5,0.036869}, {{0.96588,-0.258988,-0.00105453},{0.00109178,0,0.999999}}, true },
        { "Land_CratesShabby_F", {11796.5,13056.1,0.0375071}, {{0.96588,-0.258988,-0.00105453},{0.00109178,0,0.999999}}, true },
        { "Land_HelipadCircle_F", {11796,13104.1,0}, {{0.273294,0.961931,0},{0,0,1}}, true },
        { "Land_Pallet_MilBoxes_F", {12172.6,12960.1,0.0794954}, {{0.399485,0.91674,0},{0,0,1}}, true },
        // ATMs
        { "Land_Atm_01_F", {1888.53,12125.3,0.284561}, {{0.99453,-0.104452,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {2104.35,3439.8,0.221501}, {{0.966741,0.255759,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {2457.53,7448.89,0.257828}, {{0.319877,0.947459,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {3029.85,11331.5,0.520308}, {{0.928958,0.370186,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {5176.31,8823.1,0.10381}, {{0.185896,0.982569,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {5379.75,4080.59,0.595273}, {{-0.971422,0.237357,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {5410.69,9928.31,0.277559}, {{0,1,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {5602.78,12501.4,0.149943}, {{0.616564,-0.787305,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {5676.73,10191.7,0.239613}, {{0.156531,0.987673,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {5809.5,10855.2,0.389958}, {{-0.432223,0.901767,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {6569.07,13095.4,0.0477333}, {{-0.916388,0.40029,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {7993.48,7428.29,0.172792}, {{0.179962,-0.983674,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {8333.46,9700.11,0.563959}, {{-0.483228,-0.875495,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {8506.92,12429.8,0.4888}, {{0.181498,-0.983391,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {8959.09,10338.2,0}, {{-0.855434,0.517912,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {8947,13662.5,0.27055}, {{-0.00939054,-0.999956,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {9971.03,13451.9,0.27755}, {{-0.036167,-0.999346,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {10811,6482.04,0.277501}, {{-0.906308,-0.422618,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {10944.1,9870.03,0.487091}, {{0.997449,-0.0713866,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {11178.2,5146.3,0.457275}, {{0.0413349,-0.999145,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {11634.5,13017.3,0.277599}, {{-0.314614,-0.94922,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {11674.7,2258.52,0.33217}, {{-0.887499,-0.460809,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {12624.9,7603.27,0.253271}, {{0.513825,0.857895,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {14252.6,11504.5,0.165345}, {{-0.762126,-0.647429,0},{0,0,1}}, true },
        { "Land_Atm_01_F", {14349.2,8747.38,0.588572}, {{0.0485784,0.998819,0},{0,0,1}}, true }
	};
	staticNpcPos[] = {
        // Southern Trader Camp
        { "C_man_polo_2_F_asia", { 5031.88,5207.61, 0 }, 005 },
        { "C_man_p_fugitive_F_asia", { 5028.86, 5209.3, 0 }, 008 },
        { "C_man_shorts_1_F_asia", { 5031.05,5222.84, 0 }, 200 },
        // Eastern Trader Camp
        { "C_man_hunter_1_F", { 11786,13046.8, 0 }, 312 },
        { "C_man_shorts_1_F_asia", { 11788.4,13052.3, 0 }, 284 },
        { "C_man_shorts_4_F_asia", { 11770.8,13065.7, 0 }, 125 },
        // Western Trader Camp
        { "C_man_polo_2_F_asia", { 2018.09,10650.2, 0 }, 330 },
        { "C_man_p_fugitive_F_asia", { 2018.92, 10650.9, 0 }, 000 }
	};
	// Prefered locations for vehicles
	class whitelistedVehiclePos {};
};
